#!/usr/bin/env bash

USER_NAME=${SUDO_USER:-$USER}
USER_HOME=$(eval echo "~$USER_NAME")

# install essentials
sudo apt install nala -y
sudo nala install ninja-build gettext libtool-bin cmake g++ pkg-config unzip curl git tmux build-essential manpages-dev clangd python3-jedi zsh -y

git clone https://git.boergmann.it/klaas/shellskripte
cd shellskripte

cp ./configs/zshrc $USER_HOME/home/klaas/.zshrc

# ssh Keys für alle Maschinen
cp ./ssh/public_keys $USER_HOME/.ssh/authorized_keys

# ssh Password Authenitcatoon no
./ssh/ssh_password -n

cd ..
# install neovim
cd ..
git clone https://github.com/neovim/neovim
cd neovim
git checkout stable
make CMAKE_BUILD_TYPE=RelWithDebInfo
sudo make install
cd ..
rm -Rf neovim

# config file for nvim
mkdir ~/.config/nvim
wget https://git.boergmann.it/klaas/shellskripte/raw/branch/main/configs/init.vim -O $USER_HOME/.config/nvim/init.vim
sh -c 'curl -fLo "${XDG_DATA_HOME:-$HOME/.local/share}"/nvim/site/autoload/plug.vim --create-dirs \ https://raw.githubusercontent.com/junegunn/vim-plug/master/plug.vim'
nvim --headless +PlugInstall +qa
# Language support for python and C
nvim --headless -c 'CocInstall -sync coc-python' -c 'qall'
nvim --headless -c 'CocInstall -sync coc-clang' -c 'qall'

# Install NodeJS
curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.3/install.sh | bash
source ~/.bashrc
nvm install v20

# usefull packages für nodeJS
npm install -g yarn
npm install -g nodemon

# nvim language support for nodeJS
cd ~/.local/share/nvim/plugged/coc.nvim
yarn install
yarn build

# aufräumen
rm -Rf $USER_HOME/shellskripte

# zsh nutzen
usermod -s /bin/zsh $USER_NAME
